LookupTable (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt.image, class: LookupTable
Keywords: java.awt.image.LookupTable class

# Class LookupTable

java.lang.Object
java.awt.image.LookupTable

Direct Known Subclasses:
  `ByteLookupTable, ShortLookupTable`

public abstract class LookupTable extends Object
This abstract class defines a lookup table object. ByteLookupTable and ShortLookupTable are subclasses, which contain byte and short data, respectively. A lookup table contains data arrays for one or more bands (or components) of an image (for example, separate arrays for R, G, and B), and it contains an offset which will be subtracted from the input values before indexing into the arrays. This allows an array smaller than the native data size to be provided for a constrained input. If there is only one array in the lookup table, it will be applied to all bands. All arrays must be the same size.

See Also:
  - `ByteLookupTable`
  - `ShortLookupTable`
  - `LookupOp`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `LookupTable(int offset, int numComponents)`
  Constructs a new LookupTable from the number of components and an offset into the lookup table.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getNumComponents()`
  Returns the number of components in the lookup table.
  `int`
  `getOffset()`
  Returns the offset.
  `abstract int[]`
  `lookupPixel(int[] src, int[] dest)`
  Returns an `int` array of components for one pixel.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### LookupTable

    protected LookupTable(int offset, int numComponents)
    Constructs a new LookupTable from the number of components and an offset into the lookup table.
    Parameters:
      `offset` - the offset to subtract from input values before indexing into the data arrays for this `LookupTable`
      `numComponents` - the number of data arrays in this `LookupTable`
    Throws:
      `IllegalArgumentException` - if `offset` is less than 0 or if `numComponents` is less than 1

- ## Method Details

  - ### getNumComponents

    public int getNumComponents()
    Returns the number of components in the lookup table.
    Returns:
      the number of components in this `LookupTable`.

  - ### getOffset

    public int getOffset()
    Returns the offset.
    Returns:
      the offset of this `LookupTable`.

  - ### lookupPixel

    public abstract int[] lookupPixel(int[] src, int[] dest)
    Returns an `int` array of components for one pixel. The `dest` array contains the result of the lookup and is returned. If dest is `null`, a new array is allocated. The source and destination can be equal.
    Parameters:
      `src` - the source array of components of one pixel
      `dest` - the destination array of components for one pixel, translated with this `LookupTable`
    Returns:
      an `int` array of components for one pixel.